
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Reward_catalog_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reward_catalog_items = await db.reward_catalog_items.create(
            {
                id: data.id || undefined,
        
        item_name: data.item_name
        ||
        null
            ,
            
        item_type: data.item_type
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        cost_coins: data.cost_coins
        ||
        null
            ,
            
        inventory_quantity: data.inventory_quantity
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await reward_catalog_items.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.reward_catalog_items.getTableName(),
                belongsToColumn: 'item_images',
                belongsToId: reward_catalog_items.id,
            },
            data.item_images,
            options,
        );
        

        return reward_catalog_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const reward_catalog_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                item_name: item.item_name
            ||
            null
            ,
            
                item_type: item.item_type
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                cost_coins: item.cost_coins
            ||
            null
            ,
            
                inventory_quantity: item.inventory_quantity
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const reward_catalog_items = await db.reward_catalog_items.bulkCreate(reward_catalog_itemsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < reward_catalog_items.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.reward_catalog_items.getTableName(),
                    belongsToColumn: 'item_images',
                    belongsToId: reward_catalog_items[i].id,
                },
                data[i].item_images,
                options,
            );
        }
        

        return reward_catalog_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const reward_catalog_items = await db.reward_catalog_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.item_name !== undefined) updatePayload.item_name = data.item_name;
        
        
        if (data.item_type !== undefined) updatePayload.item_type = data.item_type;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.cost_coins !== undefined) updatePayload.cost_coins = data.cost_coins;
        
        
        if (data.inventory_quantity !== undefined) updatePayload.inventory_quantity = data.inventory_quantity;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await reward_catalog_items.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await reward_catalog_items.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.reward_catalog_items.getTableName(),
                belongsToColumn: 'item_images',
                belongsToId: reward_catalog_items.id,
            },
            data.item_images,
            options,
        );
        

        return reward_catalog_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reward_catalog_items = await db.reward_catalog_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of reward_catalog_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of reward_catalog_items) {
                await record.destroy({transaction});
            }
        });


        return reward_catalog_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const reward_catalog_items = await db.reward_catalog_items.findByPk(id, options);

        await reward_catalog_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await reward_catalog_items.destroy({
            transaction
        });

        return reward_catalog_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const reward_catalog_items = await db.reward_catalog_items.findOne(
            { where },
            { transaction },
        );

        if (!reward_catalog_items) {
            return reward_catalog_items;
        }

        const output = reward_catalog_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.reward_redemptions_reward_catalog_item = await reward_catalog_items.getReward_redemptions_reward_catalog_item({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await reward_catalog_items.getOrganization({
            transaction
        });
        
        
        output.item_images = await reward_catalog_items.getItem_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



      {
        model: db.file,
        as: 'item_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.item_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reward_catalog_items',
                        'item_name',
                        filter.item_name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reward_catalog_items',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.cost_coinsRange) {
                const [start, end] = filter.cost_coinsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    cost_coins: {
                    ...where.cost_coins,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    cost_coins: {
                    ...where.cost_coins,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.inventory_quantityRange) {
                const [start, end] = filter.inventory_quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    inventory_quantity: {
                    ...where.inventory_quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    inventory_quantity: {
                    ...where.inventory_quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.item_type) {
                where = {
                    ...where,
                item_type: filter.item_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.reward_catalog_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'reward_catalog_items',
                        'item_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.reward_catalog_items.findAll({
            attributes: [ 'id', 'item_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['item_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.item_name,
        }));
    }

    
};

